// ICEClient.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"
#include <Ice/Ice.h>
#include "Crash.h"
#include <iostream>
#include <cstdlib>

using namespace std;
using namespace Crash;
using namespace Ice;

Ice::CommunicatorPtr ic;
TestClassPrx proxy;

void init(int argc, _TCHAR* argv[])
{
    try
    {
        ic = ::Ice::initialize(argc, argv);
        ::Ice::ObjectPrx base = ic->stringToProxy("TestClass:default -h localhost -p 10000 -t 15000");
        if (!base)
            throw "Could not create proxy";
        proxy = TestClassPrx::checkedCast(base);
        if (!proxy)
            throw "Invalid proxy";
    }
    catch (const ::Ice::Exception& e)
    {
        cerr << e << endl;
    }
    catch (const char * msg)
    {
        cerr << msg << endl;
    }
    printf("init complete.\n");
}

class TestClass_AmiInvokeMethod_CallBack : public IceUtil::Shared
{
public:
    void ice_response(::Ice::Int)
    {
    }

    void ice_exception(const Exception&)
    {
        proxy = NULL;
        printf("proxy = NULL;\n");
    }

};

int _tmain(int argc, _TCHAR* argv[])
{
    init(argc, argv);
    try
    {
        Callback_TestClass_AmiInvokeMethodPtr cb = newCallback_TestClass_AmiInvokeMethod
            (new TestClass_AmiInvokeMethod_CallBack(),
            &TestClass_AmiInvokeMethod_CallBack::ice_response,
            &TestClass_AmiInvokeMethod_CallBack::ice_exception);

        proxy->begin_AmiInvokeMethod(cb);
        proxy->DirectInvokeMethod();
    }
    catch (const ::Ice::Exception& e)
    {
        cerr << e << endl;
    }
    catch (const char * msg)
    {
        cerr << msg << endl;
    }

    printf("Invoke complete.\n");

    system("pause");

    if (ic)
    {
        ic->destroy();
    }

	return 0;
}

